(*
Description: Starts the associated Windows-application
             (i.t.c. Adobe-Reader-6.0) of an pdf-file, that
             requires a file-open-password.
             After starting the programm it waits up to 30
             seconds for the window, that asks for the fo-pw.
             On success it writes the fo-pw in the edit-field
             and finaly it gives a OK-message to the OK-button.

Files required: pdf_kw.txt (const pdf_Nm_Kw). It is a simple
                2-line-text-file, that must be in the same
                directory as the *.exe-programm-file and it
                contains the complete path- and file-name of
                the *.pdf in the first line. The second line
                contains the required file-open-password.

Date: 29. September 2010

Author: Frank Eppers Wolfsburg (ffje)

Notes: Delphi 5,
       further material is available at
       swissdelphicenter.ch
       Windows 98SE,
       to adapt it to newer versions of OS's
       you will find detailed informations at
       microsoft.com
*)
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, shellapi;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Datei: TextFile;
  Pfad_Datei, KennWort: string;
  Result, Anzahl: integer;
  PWhnd, EWhnd, OWhnd: THandle;
  PD: array[0..800] of Char; // reicht ??? !!!
  KW: array[0..50] of Char; // reicht ??? !!!

const
  pdf_Nm_Kw= 'pdf_kw.txt'; // Name d. Parameter-Datei
  SleepTime= 200; // in Millisekunden
  WarteZeit= 150;
  KurzeZeit= 2;
                              
implementation

{$R *.DFM}

procedure MeldeKasten(MeldeText, TitelText: PChar);
begin
  MessageBox(0, MeldeText, TitelText, MB_OK + MB_ICONSTOP);
  Application.Terminate;
//  exit;
  Halt;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
// Parameter-Datei ffnen
  try
    AssignFile(Datei, GetCurrentDir + '\' + pdf_Nm_Kw);
    Reset(Datei);
  except
    on Exception do
    begin
      MeldeKasten('Die Parameter-Datei' + #13#10 + '     ( ' +
                  pdf_Nm_Kw + ' )' + #13#10 + 'wurde nicht gefunden.',
                  'Wichtiger Hinweis:');
    end;
  end;
// Name der pdf und das Passwort aus Parameter-Datei einlesen
  try
    Readln(Datei, Pfad_Datei);
    Readln(Datei, KennWort);
    Anzahl:= 0;
    if (Pfad_Datei = '') or (KennWort = '') then
      Anzahl:= 1 div Anzahl;
  except
    on Exception do
    begin
      CloseFile(Datei);
      MeldeKasten('Die Parameter-Datei' + #13#10 + '     ( ' +
                  pdf_Nm_Kw + ' )' + #13#10 + '     ist fehlerhaft.',
                  'Wichtiger Hinweis:');
    end;
  end;
  CloseFile(Datei);
  Application.ProcessMessages;
  StrPCopy(KW, KennWort);
  StrPCopy(PD, Pfad_Datei);
  Result:= ShellExecuteA(Application.Handle, 'open', PD, nil, nil, SW_NORMAL);
// Pfad-Datei-Name-Fehler-Message !!!
  if Result < 33 then
  begin
    MeldeKasten('Die pdf-Datei wurde nicht gefunden.',
                'Wichtiger Hinweis:');
    Application.Terminate;
    exit;
  end;
// nach Password-Window suchen
  repeat
    PWhnd:= FindWindow('#32770', 'Password');
    sleep(SleepTime);
    Application.ProcessMessages;
    Inc(Anzahl);
  until (Anzahl > WarteZeit) or (PWhnd > 0);
// Zeit-Limit-Passwort-Abfrage-Message !!!
  if Anzahl > WarteZeit then
  begin
    MeldeKasten('Wartezeit zur Passwort-Abfrage berschritten.',
               'Zeit-Fehler in den Programmablufen:');
  end;
// nach Edit- u. OK-Button-Window suchen
  if PWhnd > 0 then
  begin
    Anzahl:= 0;
    repeat
      PWhnd:= FindWindow('#32770', 'Password');
      EWhnd:= FindWindowEx(PWhnd, 0, 'Edit', nil);
      OWhnd:= FindWindowEx(PWhnd, 0, 'Button', 'OK');
      sleep(SleepTime);
      Application.ProcessMessages;
      Inc(Anzahl);
    until (Anzahl > KurzeZeit) or ((EWhnd > 0) and (OWhnd > 0));
// FindWindow-Fehler-Message !!!
    if (Anzahl > KurzeZeit) or (EWhnd = 0) or (OWhnd = 0) then
    begin
      MeldeKasten('Probleme mit dem Passwort-Formular.',
                 'Fehler bei Objektverfgbarkeiten:');
    end;
  end;
// Kennwort eingeben u. OK-Button druecken
  if (EWhnd > 0) and (OWhnd > 0) then
  begin
    Result:= SendMessage(EWhnd, WM_SETTEXT, 0, integer(@KW));
    sleep(SleepTime);
    Application.ProcessMessages;
    SendMessage(OWhnd, BM_CLICK, 0, 0);
    sleep(SleepTime);
    Application.ProcessMessages;
// SendMessage-Fehler-Message !!!
    if Result <> 1 then
    begin
      MeldeKasten('Probleme bei der Passwort-Eingabe.',
                 'Fehler bei Objektbearbeitung:');
    end;
  end;
  Application.Terminate;
end;



end.
